﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;
using SharedViews.Helpers;

namespace SharedViews
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("8125D54F-F221-4AB8-99C1-CD9C6058F790"), ProgId("SharedViews.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton masterFolderRibbonButton;
        private ADXRibbonButton folder1RibbonButton;
        private ADXRibbonButton folder2RibbonButton;
        private ADXRibbonButton setViewRibbonButton;
        private ImageList imlIcons;
        private ADXRibbonButton synchViewsRibbonButton;
        private ADXOutlookAppEvents adxOutlookEvents;
        private ADXRibbonCheckBox eventsRibbonCheckBox;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.masterFolderRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.folder1RibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.folder2RibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.setViewRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.imlIcons = new System.Windows.Forms.ImageList(this.components);
            this.synchViewsRibbonButton = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.eventsRibbonCheckBox = new AddinExpress.MSO.ADXRibbonCheckBox(this.components);
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "Outlook Views";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_b89365a784124965bd099dbad536af45";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "Outlook Folders";
            this.adxRibbonGroup1.Controls.Add(this.masterFolderRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.folder1RibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.folder2RibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.setViewRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.synchViewsRibbonButton);
            this.adxRibbonGroup1.Controls.Add(this.eventsRibbonCheckBox);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_1cb39f193d734d8ba96ec66dd45b637c";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // masterFolderRibbonButton
            // 
            this.masterFolderRibbonButton.Caption = "Master Folder  :";
            this.masterFolderRibbonButton.Id = "adxRibbonButton_197fb62b06bd4f9ba16457e90eec12e5";
            this.masterFolderRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.masterFolderRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.masterFolderRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.masterFolderRibbonButton_OnClick);
            // 
            // folder1RibbonButton
            // 
            this.folder1RibbonButton.Caption = "Watch Folder 1 :";
            this.folder1RibbonButton.Id = "adxRibbonButton_15cd93fcb40f4ece9a4cde93fe1ec4f9";
            this.folder1RibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.folder1RibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.folder1RibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.folder1RibbonButton_OnClick);
            // 
            // folder2RibbonButton
            // 
            this.folder2RibbonButton.Caption = "Watch Folder 2 :";
            this.folder2RibbonButton.Id = "adxRibbonButton_18e0555617f8429183aa5ed657e74802";
            this.folder2RibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.folder2RibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.folder2RibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.folder2RibbonButton_OnClick);
            // 
            // setViewRibbonButton
            // 
            this.setViewRibbonButton.Caption = "Create && Set View";
            this.setViewRibbonButton.Id = "adxRibbonButton_ea8d4ac58c1b4115957b8a7346c79fb8";
            this.setViewRibbonButton.Image = 0;
            this.setViewRibbonButton.ImageList = this.imlIcons;
            this.setViewRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.setViewRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.setViewRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.setViewRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.setViewRibbonButton_OnClick);
            // 
            // imlIcons
            // 
            this.imlIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlIcons.ImageStream")));
            this.imlIcons.TransparentColor = System.Drawing.Color.Transparent;
            this.imlIcons.Images.SetKeyName(0, "View");
            this.imlIcons.Images.SetKeyName(1, "Refresh");
            // 
            // synchViewsRibbonButton
            // 
            this.synchViewsRibbonButton.Caption = "Synch Folder Views";
            this.synchViewsRibbonButton.Id = "adxRibbonButton_4683902634c64c30931bf7072f76bcc6";
            this.synchViewsRibbonButton.Image = 1;
            this.synchViewsRibbonButton.ImageList = this.imlIcons;
            this.synchViewsRibbonButton.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.synchViewsRibbonButton.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.synchViewsRibbonButton.Size = AddinExpress.MSO.ADXRibbonXControlSize.Large;
            this.synchViewsRibbonButton.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.synchViewsRibbonButton_OnClick);
            // 
            // eventsRibbonCheckBox
            // 
            this.eventsRibbonCheckBox.Caption = "Sync Views on ExplorerFolderSwitch";
            this.eventsRibbonCheckBox.Id = "adxRibbonCheckBox_c1fa382eab774fea834290b2784f7aef";
            this.eventsRibbonCheckBox.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.ExplorerFolderSwitch += new AddinExpress.MSO.ADXOlExplorer_EventHandler(this.adxOutlookEvents_ExplorerFolderSwitch);
            // 
            // AddinModule
            // 
            this.AddinName = "SharedViews";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        string masterFolderPath = string.Empty;
        string folder1Path = string.Empty;
        string folder2Path = string.Empty;

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void masterFolderRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.NameSpace session = null;
            Outlook.MAPIFolder masterFolder = null;

            try
            {
                session = OutlookApp.GetNamespace("MAPI");
                masterFolder = session.PickFolder();
                if (masterFolder != null)
                {
                    masterFolderPath = masterFolder.FolderPath;
                    masterFolderRibbonButton.Caption = "Master Folder : " + masterFolderPath;
                    Properties.Settings.Default.MasterFolderPath = masterFolderPath;
                    Properties.Settings.Default.Save();
                }
            }
            finally
            {
                if (masterFolder != null)
                    Marshal.ReleaseComObject(masterFolder);
                if (session != null)
                    Marshal.ReleaseComObject(session);
            }
        }

        private void folder1RibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.NameSpace session = null;
            Outlook.MAPIFolder folder1Folder = null;

            try
            {
                session = OutlookApp.GetNamespace("MAPI");
                folder1Folder = session.PickFolder();
                if (folder1Folder != null)
                {
                    folder1Path = folder1Folder.FolderPath;
                    folder1RibbonButton.Caption = "Watch Folder 1 : " + folder1Path;
                    Properties.Settings.Default.Folder1Path = folder1Path;
                    Properties.Settings.Default.Save();
                }
            }
            finally
            {
                if (folder1Folder != null)
                    Marshal.ReleaseComObject(folder1Folder);
                if (session != null)
                    Marshal.ReleaseComObject(session);
            }
        }

        private void folder2RibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.NameSpace session = null;
            Outlook.MAPIFolder folder2Folder = null;

            try
            {
                session = OutlookApp.GetNamespace("MAPI");
                folder2Folder = session.PickFolder();
                if (folder2Folder != null)
                {
                    folder2Path = folder2Folder.FolderPath;
                    folder2RibbonButton.Caption = "Watch Folder 2 : " + folder2Path;
                    Properties.Settings.Default.Folder2Path = folder2Path;
                    Properties.Settings.Default.Save();
                }
            }
            finally
            {
                if (folder2Folder != null)
                    Marshal.ReleaseComObject(folder2Folder);
                if (session != null)
                    Marshal.ReleaseComObject(session);
            }
        }

        private void setViewRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            Outlook.MAPIFolder masterFolder = null;
            Outlook.MAPIFolder folder1 = null;
            Outlook.MAPIFolder folder2 = null;

            Outlook.Views masterFolderViews = null;
            Outlook.Views folder1Views = null;
            Outlook.Views folder2Views = null;

            Outlook.View folder1View = null;
            Outlook.View folder2View = null;

            try
            {
                // Get the folders
                masterFolder = FolderHelper.GetFolder(masterFolderPath, this.OutlookApp);
                folder1 = FolderHelper.GetFolder(folder1Path, this.OutlookApp);
                folder2 = FolderHelper.GetFolder(folder2Path, this.OutlookApp);

                // Get the folders views     
                masterFolderViews = masterFolder.Views;
                folder1Views = folder1.Views;
                folder2Views = folder2.Views;

                // Add & setup the Master View
                CreateView(masterFolderViews);

                // Apply new view to folders
                folder1View = folder1Views["My Master View"];
                folder1View.Apply();
                folder2View = folder2Views["My Master View"];
                folder2View.Apply();
            }
            finally
            {
                if (masterFolder != null)
                    Marshal.ReleaseComObject(masterFolder);
                if (folder1 != null)
                    Marshal.ReleaseComObject(folder1);
                if (folder2 != null)
                    Marshal.ReleaseComObject(folder2);
                if (masterFolderViews != null)
                    Marshal.ReleaseComObject(masterFolderViews);
                if (folder1Views != null)
                    Marshal.ReleaseComObject(folder1Views);
                if (folder2Views != null)
                    Marshal.ReleaseComObject(folder2Views);
                if (folder1View != null)
                    Marshal.ReleaseComObject(folder1View);
                if (folder2View != null)
                    Marshal.ReleaseComObject(folder2View);
            }
        }

        private void CreateView(Outlook.Views masterFolderViews)
        {
            Outlook.ViewFields masterFolderViewFields = null;
            Outlook.OrderFields masterFolderSortFields = null;
            Outlook.TableView masterView = null;

            try
            {
                masterView = masterFolderViews.Add("My Master View", Outlook.OlViewType.olTableView, Outlook.OlViewSaveOption.olViewSaveOptionAllFoldersOfType) as Outlook.TableView;
                masterFolderViewFields = masterView.ViewFields;
                masterFolderSortFields = masterView.SortFields;

                masterFolderViewFields.Add("Message Class");
                //Importance
                masterFolderViewFields.Remove("urn:schemas:httpmail:importance");
                //Reminder
                masterFolderViewFields.Remove("http://schemas.microsoft.com/mapi/id/{00062008-0000-0000-C000-000000000046}/8503000b");
                //Icon
                masterFolderViewFields.Remove("http://schemas.microsoft.com/mapi/proptag/0x0fff0102");
                //Flag Status
                masterFolderViewFields.Remove("http://schemas.microsoft.com/mapi/proptag/0x10900003");
                //Attachment
                masterFolderViewFields.Remove("urn:schemas:httpmail:hasattachment");
                //Received
                masterFolderViewFields.Remove("urn:schemas:httpmail:datereceived");
                //Categories
                masterFolderViewFields.Remove("urn:schemas-microsoft-com:office:office#Keywords");

                // Remove the Sorting
                masterFolderSortFields.RemoveAll();

                // Save & Apply the Master view 
                masterView.Save();
                masterView.Apply();
            }
            finally
            {
                if (masterView != null)
                    Marshal.ReleaseComObject(masterView);
                if (masterFolderViewFields != null)
                    Marshal.ReleaseComObject(masterFolderViewFields);
                if (masterFolderSortFields != null)
                    Marshal.ReleaseComObject(masterFolderSortFields);
            }
        }

        private void synchViewsRibbonButton_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            SynchFields();
        }

        private void ProcessFolderView(Outlook.ViewFields masterFolderFields, Outlook.ViewFields childFolderFields)
        {
            Outlook.ViewField masterField = null;
            Outlook.ViewField foundField = null;
            Outlook.View childFolderView = null;
            Outlook.View masterFolderView = null;

            try
            {
                childFolderView = childFolderFields.Parent as Outlook.View;

                for (int i = 1; i <= masterFolderFields.Count; i++)
                {
                    masterField = masterFolderFields[i];
                    foundField = childFolderFields[masterField.ViewXMLSchemaName];

                    if (foundField != null)
                    {
                        Marshal.ReleaseComObject(foundField);
                        foundField = null;
                    }
                    if (masterField != null)
                    {
                        Marshal.ReleaseComObject(masterField);
                        masterField = null;
                    }
                }
            }
            catch (COMException ex)
            {
                if (ex.ErrorCode == -2147467259)// The field does not exist in the view
                {
                    childFolderFields.Add(masterField.ViewXMLSchemaName);
                    childFolderView.Save();
                    childFolderView.Apply();
                }
            }
            finally
            {
                if (foundField != null)
                    Marshal.ReleaseComObject(foundField);
                if (masterField != null)
                    Marshal.ReleaseComObject(masterField);
            }

            try
            {
                masterFolderView = masterFolderFields.Parent as Outlook.View;

                for (int i = 1; i <= childFolderFields.Count; i++)
                {
                    masterField = childFolderFields[i];
                    foundField = masterFolderFields[masterField.ViewXMLSchemaName];

                    if (foundField != null)
                    {
                        Marshal.ReleaseComObject(foundField);
                        foundField = null;
                    }
                    if (masterField != null)
                    {
                        Marshal.ReleaseComObject(masterField);
                        masterField = null;
                    }
                }
            }
            catch (COMException ex)
            {
                if (ex.ErrorCode == -2147467259)// The field does not exist in the view
                {
                    childFolderFields.Remove(masterField.ViewXMLSchemaName);
                    childFolderView.Save();
                    childFolderView.Apply();
                }
            }
            finally
            {
                if (foundField != null)
                    Marshal.ReleaseComObject(foundField);
                if (masterField != null)
                    Marshal.ReleaseComObject(masterField);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            masterFolderPath = Properties.Settings.Default.MasterFolderPath;
            masterFolderRibbonButton.Caption = "Master Folder : " + masterFolderPath;
            folder1Path = Properties.Settings.Default.Folder1Path;
            folder1RibbonButton.Caption = "Watch Folder 1 : " + folder1Path;
            folder2Path = Properties.Settings.Default.Folder2Path;
            folder2RibbonButton.Caption = "Watch Folder 2 : " + folder2Path;
        }

        private void adxOutlookEvents_ExplorerFolderSwitch(object sender, object explorer)
        {
            if (eventsRibbonCheckBox.Pressed)
                SynchFields();
        }

        private void SynchFields()
        {
            Outlook.MAPIFolder masterFolder = null;
            Outlook.Views masterFolderViews = null;
            Outlook.TableView masterFolderView = null;
            Outlook.ViewFields masterFolderFields = null;

            Outlook.MAPIFolder folder1 = null;
            Outlook.Views folder1Views = null;
            Outlook.TableView folder1View = null;
            Outlook.ViewFields folder1Fields = null;

            Outlook.MAPIFolder folder2 = null;
            Outlook.Views folder2Views = null;
            Outlook.TableView folder2View = null;
            Outlook.ViewFields folder2Fields = null;

            try
            {
                masterFolder = FolderHelper.GetFolder(masterFolderPath, this.OutlookApp);
                masterFolderViews = masterFolder.Views;
                masterFolderView = masterFolder.CurrentView as Outlook.TableView;
                masterFolderFields = masterFolderView.ViewFields;

                folder1 = FolderHelper.GetFolder(folder1Path, this.OutlookApp);
                folder1Views = folder1.Views;
                folder1View = folder1.CurrentView as Outlook.TableView;
                folder1Fields = folder1View.ViewFields;

                folder2 = FolderHelper.GetFolder(folder2Path, this.OutlookApp);
                folder2Views = folder2.Views;
                folder2View = folder2.CurrentView as Outlook.TableView;
                folder2Fields = folder2View.ViewFields;

                if (masterFolderFields != null && folder1Fields != null)
                {
                    ProcessFolderView(masterFolderFields, folder1Fields);
                }

                if (masterFolderFields != null && folder2Fields != null)
                {
                    ProcessFolderView(masterFolderFields, folder2Fields);
                }

            }
            finally
            {
                if (folder2Fields != null)
                    Marshal.ReleaseComObject(folder2Fields);
                if (folder2View != null)
                    Marshal.ReleaseComObject(folder2View);
                if (folder2Views != null)
                    Marshal.ReleaseComObject(folder2Views);
                if (folder2 != null)
                    Marshal.ReleaseComObject(folder2);
                if (folder1Fields != null)
                    Marshal.ReleaseComObject(folder1Fields);
                if (folder1View != null)
                    Marshal.ReleaseComObject(folder1View);
                if (folder1Views != null)
                    Marshal.ReleaseComObject(folder1Views);
                if (folder1 != null)
                    Marshal.ReleaseComObject(folder1);
                if (masterFolderFields != null)
                    Marshal.ReleaseComObject(masterFolderFields);
                if (masterFolderView != null)
                    Marshal.ReleaseComObject(masterFolderView);
                if (masterFolderViews != null)
                    Marshal.ReleaseComObject(masterFolderViews);
                if (masterFolder != null)
                    Marshal.ReleaseComObject(masterFolder);
            }
        }
    }
}

