﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Outlook = Microsoft.Office.Interop.Outlook;
using System.Runtime.InteropServices;

namespace SharedViews.Helpers
{
    public static class FolderHelper
    {

        public static Outlook.Folder GetFolder(string folderPath, Outlook._Application outlookApp)
        {
            Outlook.Folder returnFolder = null;
            Outlook.Folders subFolders = null;
            Outlook.NameSpace session = null;
            Outlook.Folders sessionFolders = null;

            try
            {
                session = outlookApp.Session;
                folderPath = folderPath.TrimStart("\\".ToCharArray());
                
                String[] folders = folderPath.Split("\\".ToCharArray());
                sessionFolders = session.Folders;
                returnFolder = sessionFolders[folders[0]] as Outlook.Folder;
                                
                if (returnFolder != null)
                {
                    String folderName;
                    for (int i = 1; i < folders.Length; i++)
                    {
                        folderName = folders[i];
                        subFolders = returnFolder.Folders;
                        returnFolder = subFolders[folderName] as Outlook.Folder;
                    }
                }
            }
            catch
            {
                returnFolder = null;
            }
            finally
            {
                if (sessionFolders != null)
                    Marshal.ReleaseComObject(sessionFolders);
                if (session != null)
                    Marshal.ReleaseComObject(session);
                if (subFolders != null)
                    Marshal.ReleaseComObject(subFolders);
            }
            return returnFolder;
        }

    }
}
